let sessionNumber = 10;
require('geckodriver');
// Generated by Selenium IDE
const { Builder, By, Key, until } = require('selenium-webdriver')
const firefox = require('selenium-webdriver/firefox');
const { performance } = require('perf_hooks');
const assert = require('assert');
const fs = require('fs');
const path = require('path');
const chai = require('chai');
const expect = chai.expect;

const data = fs.readFileSync('./test/grading.json');
const jsonData = JSON.parse(data);

if(!jsonData.gradedTest.s10){

	try {

    if (!fs.existsSync('./sessions/frontend/s10/activity/index.html')) {
			throw new Error('File not found');
		  }

      //Automated Grading Integration
      // Variable to store passing unit test scores for the session
      let passingTests = 0;
      // Variable to store total number of session unit tests
      let totalTests = 0;


      function parsePixels(value) {
          return parseFloat(value.replace('px', ''));
        }

      describe('s10', function() {

        this.timeout(30000);
        const timeout = 10000;
        let driver;
        let vars;

        let internalCssTestPassed = false;

        let startTime;
        let errors = [];
        before(async function() {
          startTime = performance.now();
          // Any setup code you need to run before the tests start
          driver = await new Builder().forBrowser('firefox').setFirefoxOptions(options).build()
        });
        
        const options = new firefox.Options();
        options.headless();
  
        options.setPreference('browser.download.manager.showWhenStarting', false);
        options.setPreference('browser.download.manager.useWindow', false);
  
        beforeEach(async function() {

          totalTests += 1;
          vars = {}
        })
  
        afterEach(function(){
  
          if(this.currentTest.state === "passed"){
            passingTests += 1;
          }
  
          process.removeAllListeners(); 


          if (this.currentTest.state === 'failed') {
            errors.push({
                test: this.currentTest.title,
                feedback: this.currentTest.err.message
            });
        }
  
        })

        it('check universal css reset', async function() {
          const filePath = path.join(__dirname, '..','sessions','frontend','s09','activity','index.html');
          const url = `file://${filePath}`;
          await driver.get(url);

            // Find the pre-footer section by id
            const html = await driver.findElement(By.css('html'));
            const margin = await html.getCssValue('margin');
            const padding = await html.getCssValue('padding');
            const boxSizing = await html.getCssValue('box-sizing');

            expect(margin).to.equal("0px","no css reset");
            expect(padding).to.equal("0px","no css reset");
            expect(boxSizing).to.equal("border-box","no css reset");
            
        });

        it('check page buttons has correct properties', async function() {
            const filePath = path.join(__dirname, '..','sessions','frontend','s10','activity','index.html');
            const url = `file://${filePath}`;
            await driver.get(url);
  
            const buttons = await driver.findElements(By.css('button'));
            for(let i = 0; i < buttons.length; i++){
                const color = await buttons[i].getCssValue('color');
                const padding = await buttons[i].getCssValue('padding').then(parsePixels);
                const width = await buttons[i].getCssValue('width').then(parsePixels);
                const fontSize = await buttons[i].getCssValue('font-size').then(parsePixels);
                const fontWeight = await buttons[i].getCssValue('font-weight').then(parsePixels);
                const borderClr = await buttons[i].getCssValue('border-color');
                const borderRadius = await buttons[i].getCssValue('border-radius').then(parsePixels);

                expect(color).to.include("rgb(255, 255, 255)","Button text color is not white.");
                expect(padding).to.be.at.least(1,"Button padding is not at least 10px");
                expect(width).to.be.at.least(1,"Button width is not at least 9rem");
                expect(fontSize).to.be.at.least(1,"Button font size is not at least 1rem");
                expect(fontWeight).to.be.at.least(1,"Button font weight is not at least 600");
                expect(borderClr).to.include("rgba(0, 0, 0, 0)","Button border color is not transparent.");
                expect(borderRadius).to.be.at.least(1,"Button Border Radius is not enough.");
            }
  
        });

        it('check nav has correct properties', async function() {
            const filePath = path.join(__dirname, '..','sessions','frontend','s10','activity','index.html');
            const url = `file://${filePath}`;
            await driver.get(url);
  
            const nav = await driver.findElement(By.css('nav'));;
            const padding = await nav.getCssValue('padding').then(parsePixels);
            const position = await nav.getCssValue('position');
            const top = await nav.getCssValue('top').then(parsePixels);
            const zIndex = await nav.getCssValue('z-index').then(parsePixels);
            const bgColor = await nav.getCssValue('background-color');

            // expect(color).to.include("rgb(255, 255, 255)","Button text color is not white.");
            expect(padding).to.be.at.least(1,"nav padding is not at least 1px");

            expect(position).to.include("sticky","nav position is not sticky.");
            expect(top).to.be.equal(0,"nav top property is not 0");
            expect(zIndex).to.be.equal(1,"nav z-index is not 1");
            expect(bgColor).to.include("rgb(255, 255, 255)","nav bgcolor is not white");
  
        });

        it('check nav div has correct properties', async function() {
            const filePath = path.join(__dirname, '..','sessions','frontend','s10','activity','index.html');
            const url = `file://${filePath}`;
            await driver.get(url);
  
            const rightDiv = await driver.findElement(By.css('nav ul div'));;
            const float = await rightDiv.getCssValue('float');

            expect(float).to.include("right","nav div is not floated to the right.");
  
        });

        it('check nav ul li has correct properties', async function() {
            const filePath = path.join(__dirname, '..','sessions','frontend','s10','activity','index.html');
            const url = `file://${filePath}`;
            await driver.get(url);
  
            const divLinks = await driver.findElements(By.css('nav div li'));
            for(let i = 0; i < divLinks.length; i++){
                const type = await divLinks[i].getCssValue('list-style-type');
                const display = await divLinks[i].getCssValue('display');
    
                expect(type).to.include("none","nav div li is has list style type.");
                expect(display).to.include("inline-block","nav div li is not inline-block");
            }
        });

        it('class nav and nav-logo has correct properties', async function() {
            const filePath = path.join(__dirname, '..','sessions','frontend','s10','activity','index.html');
            const url = `file://${filePath}`;
            await driver.get(url);
  
            const navLinks = await driver.findElements(By.css('.nav'));
            for(let i = 0; i < navLinks.length; i++){
                const margin = await navLinks[i].getCssValue('margin').then(parsePixels);
                const paddings = await navLinks[i].getCssValue('padding').then(parsePixels);
    
                expect(margin).to.be.at.least(1,"class nav does not have enough margin.");
                expect(paddings).to.be.at.least(1,"class nav does not have enough padding");
            }

            const navLogos = await driver.findElements(By.css('.nav-logo'));
            for(let i = 0; i < navLogos.length; i++){
                const margin = await navLogos[i].getCssValue('margin').then(parsePixels);
                const paddings = await navLogos[i].getCssValue('padding').then(parsePixels);
    
                expect(margin).to.be.at.least(1,"class nav does not have enough margin.");
                expect(paddings).to.be.at.least(1,"class nav does not have enough padding");
            }
        });

        it('logo element has correct properties', async function() {
            const filePath = path.join(__dirname, '..','sessions','frontend','s10','activity','index.html');
            const url = `file://${filePath}`;
            await driver.get(url);
  
            const logo = await driver.findElement(By.css('#logo'));

            const paddingTop = await logo.getCssValue('padding-top').then(parsePixels);
            const paddingLeft = await logo.getCssValue('padding-left').then(parsePixels);

            expect(paddingLeft).to.be.at.least(1,"class nav does not have enough padding-left.");
            expect(paddingTop).to.be.at.least(1,"class nav does not have enough padding-top.");
        });

        it('nav button element has correct properties', async function() {
            const filePath = path.join(__dirname, '..','sessions','frontend','s10','activity','index.html');
            const url = `file://${filePath}`;
            await driver.get(url);
  
            const navBtn = await driver.findElement(By.css('.tuitt-button'));

            const bgColor = await navBtn.getCssValue('background-color');

            expect(bgColor).to.equal("rgb(194, 25, 91)","nav button does not have correct color.");
        });

        it('#bg-image has correct properties', async function() {
            const filePath = path.join(__dirname, '..','sessions','frontend','s10','activity','index.html');
            const url = `file://${filePath}`;
            await driver.get(url);
  
            const bgImage = await driver.findElement(By.css('#bg-image'));

            const bg = await bgImage.getCssValue('background-image');
            const backgroundRepeat = await driver.executeScript(
                'return getComputedStyle(arguments[0]).backgroundRepeat',
                bgImage
              );
            const bgPosition = await bgImage.getCssValue('background-position');
            const bgSize = await bgImage.getCssValue('background-size');
            const paddingTop = await bgImage.getCssValue('padding-top').then(parsePixels);
            const paddingBottom = await bgImage.getCssValue('padding-bottom').then(parsePixels);
            const color = await bgImage.getCssValue('color');

            expect(bg).to.include("linear-gradient(rgba(0, 0, 0,","bg image has no semi transparent tint")
            expect(bg).to.include('url("https://d3ojsfl21hfxhc.cloudfront.net/assets/zuitt/programdetails2_w.jpg")',"bg image has no correct url")
            expect(backgroundRepeat).to.include('no-repeat','#bg-image image repeats');
            expect(bgPosition).to.include('50% 50%','#bg-image is not centered.');
            expect(bgSize).to.include('cover','#bg-image bg size is not cover');
            expect(paddingTop).to.be.at.least(1,"#bg-image does not have enough padding-top.");
            expect(paddingBottom).to.be.at.least(1,"#bg-image does not have enough padding-bottom.");
            expect(color).to.include("rgb(255, 255, 255)","#bg-image does not have white text");


        });


        it('container class has correct properties', async function() {
            const filePath = path.join(__dirname, '..','sessions','frontend','s10','activity','index.html');
            const url = `file://${filePath}`;
            await driver.get(url);

            const parentElement = await driver.findElement(By.css('#bg-image')); // Replace with the CSS selector of the parent element
            const childElement = await driver.findElement(By.css('.container')); // Replace with the CSS selector of the child element
        
            const parentRect = await parentElement.getRect();
            const childRect = await childElement.getRect();
        
            const isMovedToRight = childRect.x > parentRect.x + parentRect.width / 2;
            
            expect(isMovedToRight).to.be.true;


        });

        it('title class has correct properties', async function() {
            const filePath = path.join(__dirname, '..','sessions','frontend','s10','activity','index.html');
            const url = `file://${filePath}`;
            await driver.get(url);

            const title = await driver.findElement(By.css('.title')); // Replace with the CSS selector of the
        
            const font = await title.getCssValue('font-family');
            const size = await title.getCssValue('font-size').then(parsePixels);
            const weight = await title.getCssValue('font-weight').then(parsePixels);
        
            
            expect(font).to.include("Zilla Slab","Title font is not set as Zilla-Slab")
            expect(size).to.be.at.least(40,"Title size is not at least 2.5rem")
            expect(weight).to.be.at.least(600,"Title font weight is not at least 600")

        });

        it('subtitle class has correct properties', async function() {
            const filePath = path.join(__dirname, '..','sessions','frontend','s10','activity','index.html');
            const url = `file://${filePath}`;
            await driver.get(url);

            const subtitle = await driver.findElement(By.css('.subtitle')); // Replace with the CSS selector of the
        
            const font = await subtitle.getCssValue('font-family');
            const size = await subtitle.getCssValue('font-size').then(parsePixels);
            const marginTop = await subtitle.getCssValue('margin-top').then(parsePixels);
            const marginLeft = await subtitle.getCssValue('margin-left').then(parsePixels);
            const weight = await subtitle.getCssValue('font-weight').then(parsePixels);
        
            expect(size).to.be.at.least(1,"subtitle size is not at least 2.5rem")
            expect(weight).to.be.at.least(1,"subtitle font weight is not at least 600")
            expect(marginTop).to.be.at.least(1,"subtitle margin top is not at least 1em")
            expect(marginLeft).to.be.at.least(1,"subtitle margin left is not at least 144")

        });

        it('#apply-button has correct properties', async function() {
            const filePath = path.join(__dirname, '..','sessions','frontend','s10','activity','index.html');
            const url = `file://${filePath}`;
            await driver.get(url);

            const applyBtn = await driver.findElement(By.css('.apply-button'));
            const marginTop = await applyBtn.getCssValue('margin-top').then(parsePixels);
            const bgColor = await applyBtn.getCssValue('background-color');

            expect(bgColor).to.include("rgb(194, 25, 91)","apply button bg color is not correct")
            expect(marginTop).to.be.at.least(1,"apply button margin top is not at least 1em")

        });

        it('#main has correct properties', async function() {
          const filePath = path.join(__dirname, '..','sessions','frontend','s10','activity','index.html');
          const url = `file://${filePath}`;
          await driver.get(url);

          const main = await driver.findElement(By.css('#main'));
          const paddingTop = await main.getCssValue('padding-top').then(parsePixels);
          const textAlign = await main.getCssValue('text-align');
      
          expect(textAlign).to.include("center","#main text is not centered.")
          expect(paddingTop).to.be.at.least(1,"#main padding top is not at least 1em")

      });

      it('#main p elements have correct properties', async function() {
        const filePath = path.join(__dirname, '..','sessions','frontend','s10','activity','index.html');
        const url = `file://${filePath}`;
        await driver.get(url);

        const paragraphs = await driver.findElements(By.css('#main p'));
        for(let i = 0; i < paragraphs.length; i++){
          const weight = await paragraphs[i].getCssValue('font-weight').then(parsePixels);
          const marginTop = await paragraphs[i].getCssValue('margin-top').then(parsePixels);
          const marginBottom = await paragraphs[i].getCssValue('margin-bottom').then(parsePixels);

          expect(marginTop).to.be.at.least(1,"#main p do not have enough padding-top");
          expect(marginBottom).to.be.at.least(1,"#main p do not have enough padding-bottom");
          expect(weight).to.be.at.least(100,"#main p do not have enough font-weight");

        }

      });

      it('#book-button have correct properties', async function() {
        const filePath = path.join(__dirname, '..','sessions','frontend','s10','activity','index.html');
        const url = `file://${filePath}`;
        await driver.get(url);

        const bookBtn = await driver.findElement(By.css('.book-button'));
        const bgColor = await bookBtn.getCssValue('background-color');
        expect(bgColor).to.be.include("rgb(51, 101, 137)","book button does not have the correct bg color");

      });

      it('footer have correct properties', async function() {
        const filePath = path.join(__dirname, '..','sessions','frontend','s10','activity','index.html');
        const url = `file://${filePath}`;
        await driver.get(url);

        const footer = await driver.findElement(By.css('footer'));
        const marginTop = await footer.getCssValue('margin-top').then(parsePixels);
        const padding = await footer.getCssValue('padding').then(parsePixels);
        const textAlign = await footer.getCssValue('text-align');
        expect(marginTop).to.be.at.least(1,"footer does not have enough margin-top");
        expect(padding).to.be.at.least(1,"footer padding is not enough");
        expect(textAlign).to.include("center","footer text-alignment is not center");
        //expect(bgColor).to.be.include("rgb(51, 101, 137)","book button does not have the correct bg color");

      });

      it('footer span elements have correct properties', async function() {
        const filePath = path.join(__dirname, '..','sessions','frontend','s10','activity','index.html');
        const url = `file://${filePath}`;
        await driver.get(url);

        const footerSpans = await driver.findElements(By.css('footer span'));
        for(let i = 0; i < footerSpans.length; i++){
          const weight = await footerSpans[i].getCssValue('font-weight').then(parsePixels);
          const marginLeft = await footerSpans[i].getCssValue('margin-left').then(parsePixels);
          const marginRight = await footerSpans[i].getCssValue('margin-right').then(parsePixels);

          expect(marginLeft).to.be.at.least(1,"footer span do not have enough padding-top");
          expect(marginRight).to.be.at.least(1,"footer span do not have enough padding-bottom");
          expect(weight).to.be.at.least(100,"footer span do not have enough font-weight");

        }

      });



      after(async function () {

        const endTime = performance.now();
        const totalTime = (endTime - startTime) / 1000; // Convert to seconds
        expect(`Total time taken: ${totalTime} seconds`);
        
        
        global.gradesObject["s10"] = {
          grade: `${passingTests/totalTests >= 0.75 ? "P" : "F"}`,
          score: `${passingTests}/${totalTests}`,
          feedback: errors.length ? errors : "No Errors"
        }
        
        jsonData.gradedTest.s10 = true;
        await fs.writeFileSync('./test/grading.json', JSON.stringify(jsonData,null,4));
        
        await driver.quit(); 
      });

    })	

	
    } catch (err) {
      if(err.code === "MODULE_NOT_FOUND" || err.message === "File not found"){
        console.error(`s${sessionNumber} cannot be found. Check activity folder.`);
      } else {
        console.log(err)
      }
    }
} else {
	console.log("s10 - Tested");
}






